﻿-- MODULE FOR HOPPING FRAME --


-- Holder frame
hopAddon.hopFrame = CreateFrame("Frame",nil,hopAddon)
local hopFrame = hopAddon.hopFrame
hopAddon.hopFrame:SetSize(HOPADDON_WIDTH,HOPADDON_HEIGHT)
hopAddon.hopFrame:SetPoint("BOTTOM",0,0)
hopAddon.hopFrame.lastUpdate = 0
hopAddon.hopFrame.queueUpdate = 0
hopAddon.hopFrame:Hide()

hopAddon.hopFrame.background = hopAddon.hopFrame:CreateTexture(nil,"BORDER")
hopAddon.hopFrame.background:SetSize(HOPADDON_WIDTH+106,HOPADDON_HEIGHT-10)
hopAddon.hopFrame.background:SetPoint("BOTTOM",1,5)
hopAddon.hopFrame.background:SetTexture("Interface\\Challenges\\challenges-besttime-bg")

hopAddon.hopFrame.stringCurRealm = hopAddon.hopFrame:CreateFontString("currentRealm", "OVERLAY", "GameFontNormal")
hopAddon.hopFrame.stringCurRealm:SetPoint("CENTER",0,35)
hopAddon.hopFrame.stringCurRealm:SetText(FRIENDS_LIST_REALM)

hopAddon.hopFrame.stringRealm = hopAddon.hopFrame:CreateFontString("realmname", "OVERLAY", "QuestFont_Shadow_Huge")
hopAddon.hopFrame.stringRealm:SetPoint("CENTER",0,20)
hopAddon.hopFrame.stringRealm:SetTextColor(1, 0.914, 0.682, 1)
hopAddon.hopFrame.stringRealm:SetText(GetRealmName())

-- Dropdown to select party size to hop in

hopAddon.hopFrame.dropDown = CreateFrame("Frame", "CountDrop", hopAddon.hopFrame, "UIDropDownMenuTemplate")
hopAddon.hopFrame.dropDown:SetPoint("BOTTOM",55,35)
UIDropDownMenu_SetWidth(hopAddon.hopFrame.dropDown,86)
function hopAddon.hopFrame.dropDown_OnClick(self)
	UIDropDownMenu_SetSelectedID(hopAddon.hopFrame.dropDown, self:GetID())
end
-- list of options in droplist
local groupSizeList = {
	PARTY.." 1-4",
	RAID.." 6-40",
	HOPADDON_ANYSIZE
}
hopAddon.hopFrame.dropDown.initialize = function(self,level)
	if not level then return end
	local info = UIDropDownMenu_CreateInfo()
	for k,v in pairs(groupSizeList) do
		info = UIDropDownMenu_CreateInfo()
		info.text = v
		info.value = v
		info.func = hopAddon.hopFrame.dropDown_OnClick
		UIDropDownMenu_AddButton(info,level)
	end
end
UIDropDownMenu_Initialize(hopAddon.hopFrame.dropDown, hopAddon.hopFrame.dropDown.initialize)
UIDropDownMenu_SetSelectedID(hopAddon.hopFrame.dropDown, 3)
UIDropDownMenu_SetText(hopAddon.hopFrame.dropDown,HOPADDON_ANYSIZE)

-- Button to hop to the next realm 
hopAddon.hopFrame.buttonHop = CreateFrame("Button",nil,hopAddon.hopFrame,"UIGoldBorderButtonTemplate")
hopAddon.hopFrame.buttonHop:SetSize(100,24)
hopAddon.hopFrame.buttonHop:SetPoint("BOTTOM",55,15)
hopAddon.hopFrame.buttonHop:SetText(HOPADDON_NEXTREALM)
hopAddon.hopFrame.buttonHop:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
	GameTooltip:SetText(HOPADDON_HOPHELP)
	GameTooltip:Show()
end)
hopAddon.hopFrame.buttonHop:SetScript("OnLeave", function(self)
	GameTooltip:Hide()
end)

-- String to show last realm put in the blacklist
hopAddon.hopFrame.lastRealm = CreateFrame("Frame",nil,hopAddon.hopFrame)
local lRealm = hopAddon.hopFrame.lastRealm
lRealm:SetPoint("TOPLEFT",hopAddon.hopFrame,"LEFT",6,5)
lRealm:SetSize(120,100)
lRealm.header = lRealm:CreateFontString("lastRealmHeader", "OVERLAY", "GameFontNormal")
lRealm.header:SetPoint("TOP",0,0)
lRealm.header:SetText(HOPADDON_LASTREALM)

lRealm.text = lRealm:CreateFontString("lastRealm", "OVERLAY", "QuestFont_Shadow_Huge")
lRealm.text:SetPoint("TOP",0,-12)
lRealm.text:SetSize(110,20)
lRealm.text:SetTextColor(1, 0.914, 0.682, 1)
lRealm.text:SetText("")

lRealm:Hide()

-- Button to hop to the last blacklisted realm
hopAddon.hopFrame.buttonHopBack = CreateFrame("Button",nil,hopAddon.hopFrame,"UIGoldBorderButtonTemplate")
hopAddon.hopFrame.buttonHopBack:SetSize(100,24)
hopAddon.hopFrame.buttonHopBack:SetPoint("BOTTOM",-55,15)
hopAddon.hopFrame.buttonHopBack:SetText(HOPADDON_LASTBUTTON)
hopAddon.hopFrame.buttonHopBack:Disable()

-- MAIN FUNCTIONS --
local QUEUE_INTERVAL = 1
local SEARCH_INTERVAL = 2.5

local autoAccept = true -- auto accept invites when you're invited during server hopping


-----------
hopFrame.firstTime = true
hopFrame.hopRequest = false
local BlackList = {} -- list of pairs {realm name = time last visited}
local HopList= {} -- sorted list of groups available for server hopping
local lastUpdate = 0 -- update timer
local lastServer = nil -- last server you've hopped to
local blacklistLength = 900 -- for how much seconds realm should be ignored


local hopSearch = false -- should addon queue hopSearch
local queue = false -- should addon queue for groups
local backSearch = false -- start searching for a last server you've hopped on


local function HopSearch()
	HopList = {}
	FullScaleSearch(6,"",0,0)
end

function LeaveAndBlackList()
	local index = GetNumGroupMembers()
	local name, server
	
	if IsInRaid() then
		for i=1,index do
			if UnitIsGroupLeader("raid"..i) then
				name,server = UnitName("raid"..i)
				server = server or GetRealmName()
				BlackList[server]=GetTime()
			end
		end
	else
		for i=1,5 do
			if UnitIsGroupLeader("party"..i) then
				name,server = UnitName("party"..i)
				server = server or GetRealmName()
				BlackList[server]=GetTime()
			end
		end
	end
	--print(server)
	lastServer = server

	local blackCount = 0
	for k,v in pairs(BlackList) do
		if GetTime()-v < blacklistLength then
			blackCount = blackCount + 1
		end
	end
	hopAddon.optionsFrame.hopSearchOptionsFrame.blacklistString:SetText(HOPADDON_INBLACKLIST..""..blackCount)
	
	LeaveParty()
	
	if lastServer ~= nil then
		lRealm.text:SetText(lastServer)
		lRealm:Show()
	end
end


function FinishHopSearch()
	hopFrame.hopRequest = false	
	hopSearch = false
	queue = false
	hopAddon.hopFrame.lastUpdate = 0
	backSearch = false
		
	if (lastServer ~= nil) then
		hopAddon.hopFrame.buttonHopBack:Enable()
	end
	hopAddon.hopFrame.buttonHop:SetText(HOPADDON_NEXTREALM)
	hopAddon.hopFrame.buttonHop:Enable()
end

local function PlayerRealm(fullname)
    fullname = fullname or "???-???"
    local name, realm = strsplit(_G.REALM_SEPARATORS, fullname)
    realm = realm or GetRealmName();
    return realm;
end


local function QueueGroups()

	local apps = C_LFGList.GetApplications()
	for i=1,#apps do
		local id, appStatus, pendingStatus = C_LFGList.GetApplicationInfo(apps[i]);
		
		if appStatus == "applied" or pendingStatus == "applied" then
			C_LFGList.CancelApplication(apps[i])
		elseif pendingStatus == "invited" or appStatus == "invited" then
			LFGListInviteDialog.DeclineButton:Click()
		end
	end

	-- if we're in a group system will create shadow group
	if not IsInGroup() and not IsInRaid() then
		local tank, heal, dd = C_LFGList.GetAvailableRoles()
		
		--print(#HopList.." available. Throwing requests...")
		local appliedCount = 0
		for k,v in pairs(HopList) do
			if k==6 then break end
			appliedCount = appliedCount + 1
			C_LFGList.ApplyToGroup(v, "", tank, heal, dd)
			--print("Applying "..v)
		end
		
		if #HopList > 0 then
			for i=1,appliedCount do
				table.remove(HopList,1)
			end
		else
			queue = false
			hopAddon.hopFrame.buttonHop:SetText(HOPADDON_SEARCHING)			
			hopSearch = true
		end
	end
	
end

local function FilterHopSearchGroups()
	hopFrame.buttonHop:SetText(HOPADDON_HOPPING)

	HopList = {}
	local count, list = C_LFGList.GetSearchResults()
	if count > HOPADDON_MAX_RESULTS then count = HOPADDON_MAX_RESULTS end
	--print(count.." groups found.")
	
	if (backSearch) then
		for i = 1,count do
			if list[i]~= nil then
				local id, action, caption, desc, voice, ilvl, time, bnetfr, charfr, guild, delisted, fullname, pcount, autoinv = C_LFGList.GetSearchResultInfo(list[i])
				local realm = PlayerRealm(fullname)
		
				if fullname ~= nil and lastServer == realm then
					if UIDropDownMenu_GetSelectedID(hopAddon.hopFrame.dropDown) == 1 then
						if pcount < 5 then
							table.insert(HopList, id)
						end
					elseif UIDropDownMenu_GetSelectedID(hopAddon.hopFrame.dropDown) == 2 then
						if pcount >= 6 then
							table.insert(HopList, id)
						end
					else
						table.insert(HopList, id)
					end				
				end
			end
		end			
	else
	-- forward search
		local unfiltered = {}
		
		-- Adding all available groups that don't match blacklist
		for i = 1,count do
			if list[i] ~= nil then
				local id, action, caption, desc, voice, ilvl, time, bnetfr, charfr, guild, delisted, fullname, pcount, autoinv = C_LFGList.GetSearchResultInfo(list[i])
				local realm = PlayerRealm(fullname)

				if fullname ~= nil
				and (BlackList[realm] == nil or (GetTime()-BlackList[realm] > blacklistLength)) then
					if not hopAddon.optionsFrame.hopSearchOptionsFrame.autoInviteCheck:GetChecked() then
						-- if putting all groups filter autoivite on top
						if UIDropDownMenu_GetSelectedID(hopAddon.hopFrame.dropDown) == 1 then
							if pcount < 5 then
								unfiltered[id] = autoinv
							end
						elseif UIDropDownMenu_GetSelectedID(hopAddon.hopFrame.dropDown) == 2 then
							if pcount >= 6 then
								unfiltered[id] = autoinv
							end
						else
							unfiltered[id] = autoinv
						end
					elseif autoinv then
						-- if putting only autoinvite then don't need to sort
						if UIDropDownMenu_GetSelectedID(hopAddon.hopFrame.dropDown) == 1 then
							if pcount < 5 then
								table.insert(HopList,id)
							end
						elseif UIDropDownMenu_GetSelectedID(hopAddon.hopFrame.dropDown) == 2 then
							if pcount >= 6 then
								table.insert(HopList,id)
							end
						else
							table.insert(HopList,id)
						end
					end
				end		
			end
		end
		
		if not hopAddon.optionsFrame.hopSearchOptionsFrame.autoInviteCheck:GetChecked() then
			-- checking unfiltered for autoinvite, putting them on top first
			for id,auto in pairs(unfiltered) do
				if auto then table.insert(HopList,id) end
			end
			-- then putting simple invites
			for id,auto in pairs(unfiltered) do
				if not auto then table.insert(HopList,id) end
			end
		end

	end

	-- queue if found any
	if #HopList > 0 then
		hopAddon.hopFrame.queueUpdate = QUEUE_INTERVAL
		queue = true
	else -- search more if couldn't find any
		hopAddon.hopFrame.buttonHop:SetText(HOPADDON_SEARCHING)
		hopSearch = true
	end
end

function ServerHop_HopForward()
	hopFrame.buttonHop:Disable()
	hopFrame.buttonHopBack:Disable()
	hopFrame.buttonHop:SetText(HOPADDON_HOPPING)

	LeaveAndBlackList()
	
	hopFrame.hopRequest = true
	
	-- make sure to get a search from category 6
	if hopFrame.firstTime then
		hopFrame.lastUpdate = SEARCH_INTERVAL
		hopFrame.buttonHop:SetText(HOPADDON_SEARCHING)
		hopSearch = true
	else
		FilterHopSearchGroups()
	end
end

function ServerHop_HopBack()
	if lastServer ~= nil then
		hopFrame.buttonHop:Disable()
		hopFrame.buttonHopBack:Disable()
		hopFrame.buttonHop:SetText(HOPADDON_HOPPING)

		LeaveParty()
		
		hopFrame.hopRequest = true
		backSearch = true
		
		-- make sure to get a search from category 6
		if hopFrame.firstTime then
			hopFrame.lastUpdate = SEARCH_INTERVAL
			hopAddon.hopFrame.buttonHop:SetText(HOPADDON_SEARCHING)
			hopSearch = true
		else
			FilterHopSearchGroups()
		end
	end
end

-- hop forward button
hopAddon.hopFrame.buttonHop:SetScript("OnClick", function(btn)
	ServerHop_HopForward()
end)

hopAddon.hopFrame.buttonHopBack:SetScript("OnClick", function(btn)
	ServerHop_HopBack()
end)

local function HopFrame_EventSystem(self, event, ...)
	local arg1 = ...

	if event == "LFG_LIST_SEARCH_RESULTS_RECEIVED" then
		if hopFrame.hopRequest then
			if hopSearch then
				hopFrame.firstTime = false
				hopSearch = false
				FilterHopSearchGroups()
			end
		else
			hopFrame.firstTime = true
		end
	end
	
	if event == "LFG_LIST_SEARCH_RESULT_UPDATED" then
		if hopFrame.hopRequest then
			local apps = C_LFGList.GetApplications();
			for i=1, #apps do
				local id, status, pendingStatus = C_LFGList.GetApplicationInfo(apps[i]);
				if status == "invited" and not pendingStatus then
					LFGListInviteDialog.AcceptButton:Click()
					--print("Joining "..apps[i])
					FinishHopSearch()
					
					for i=1, #apps-1 do
						LFGListInviteDialog.AcknowledgeButton:Click()
					end
					
					break
				end
			end
		end
	end
	if event == "LFG_LIST_SEARCH_FAILED" then
		
		-- old method used this
		
	end
	if event == "GROUP_ROSTER_UPDATE" then
		-- Checking Server Name
		local index = GetNumGroupMembers()
		local name, server
		if IsInRaid() then
			for i=1,index do
				if UnitIsGroupLeader("raid"..i) then
					name,server = UnitName("raid"..i)
					server = server or GetRealmName()
				end
			end
		elseif IsInGroup() then
			for i=1,5 do
				if UnitIsGroupLeader("party"..i) then
					name,server = UnitName("party"..i)
					server = server or GetRealmName()
				end
			end
		else
			server = GetRealmName()
		end
		hopAddon.hopFrame.stringRealm:SetText(server)
	
	end
	--[[ merged into application
	if event == "LFG_LIST_JOINED_GROUP" then
		--print("Joined")

		local apps = C_LFGList.GetApplications();

		for i=1, #apps-1 do
			LFGListInviteDialog.AcknowledgeButton:Click()
		end
	end
	]]
end

hopAddon.hopFrame:SetScript("OnEvent", HopFrame_EventSystem)
hopAddon.hopFrame:RegisterEvent("LFG_LIST_SEARCH_RESULT_UPDATED")
hopAddon.hopFrame:RegisterEvent("LFG_LIST_SEARCH_FAILED")
hopAddon.hopFrame:RegisterEvent("LFG_LIST_SEARCH_RESULTS_RECEIVED")
hopAddon.hopFrame:RegisterEvent("GROUP_ROSTER_UPDATE")



local function OnUpdate(self,elapsed)
	if hopFrame.hopRequest then
		hopAddon.hopFrame.lastUpdate = hopAddon.hopFrame.lastUpdate + elapsed
		hopAddon.hopFrame.queueUpdate = hopAddon.hopFrame.queueUpdate + elapsed
		
		if (hopSearch and hopAddon.hopFrame.lastUpdate > SEARCH_INTERVAL) then
			HopSearch()
			hopAddon.hopFrame.lastUpdate = 0
		end
		
		-- Queuing for groups made found with hop search
		if (queue and hopAddon.hopFrame.queueUpdate > QUEUE_INTERVAL) then
			QueueGroups()
			hopAddon.hopFrame.queueUpdate = 0
		end
			
	end
end

local hoppingEventFrame = CreateFrame("Frame")
hoppingEventFrame:SetScript("OnUpdate",OnUpdate)